<template>
  <v-tooltip right>
    <template #activator="{on, attrs}">
      <!-- The close/open button -->
      <v-btn
        v-bind="attrs"
        icon
        v-on="on"
        @click="minified = !minified"
      >
        <!-- the button icon container -->
        <div
          class="nav-icon"
          :class="{ open }"
        >
          <!-- The bars of the close/open button -->
          <span />
          <span />
          <span />
        </div>
      </v-btn>
    </template>
    {{ $t(open ? 'button.nav-close' : 'button.nav-open') }}
  </v-tooltip>
</template>

<script lang="ts">
import { Vue, Component, VModel } from 'vue-property-decorator';

@Component({})
export default class HamburgerCloseButton extends Vue {
  @VModel({ default: false })
  minified!: boolean;

  get open(): boolean {
    return !this.minified;
  }
}
</script>
<style lang="scss" scoped>

// Credits: https://codepen.io/designcouch/pen/Atyop

.nav-icon {
  width: 20px;
  height: 15px;
  position: relative;
  transform: rotate(0deg);
  transition: .5s ease-in-out;
  cursor: pointer;
}

.nav-icon span {
  display: block;
  position: absolute;
  height: 2px;
  width: 100%;
  background: white;
  opacity: 1;
  left: 0;
  transform: rotate(0deg);
  transition: .25s ease-in-out;
  border-radius: 2px;
}

.nav-icon span:nth-child(1) {
  top: 0px;
}

.nav-icon span:nth-child(2) {
  top: 6px;
}

.nav-icon span:nth-child(3) {
  bottom: 1px;
}

.nav-icon.open span:nth-child(1) {
  transform: rotate(-45deg) translate(-2.7px, 0.5px);
  width: 12px;
  height: 2px;
}

.nav-icon.open span:nth-child(3) {
  transform: rotate(45deg) translate(-2.7px, -0.5px);
  width: 12px;
  height: 2px;
}
</style>
